diff --git a/gnu/packages/python-check.scm b/gnu/packages/python-check.scm
index eb6a6852c6..05a378601f 100644
--- a/gnu/packages/python-check.scm
+++ b/gnu/packages/python-check.scm
@@ -13,7 +13,6 @@
 ;;; Copyright © 2021 Brendan Tildesley <mail@brendan.scot>
 ;;; Copyright © 2021 Guillaume Le Vaillant <glv@posteo.net>
 ;;; Copyright © 2021 Bonface Munyoki Kilyungi <me@bonfacemunyoki.com>
-;;; Copyright © 2022 Giacomo Leidi <goodoldpaul@autistici.org>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -39,7 +38,6 @@ (define-module (gnu packages python-check)
   #:use-module (gnu packages python-web)
   #:use-module (gnu packages python-xyz)
   #:use-module (gnu packages qt)
-  #:use-module (gnu packages version-control)
   #:use-module (gnu packages web)
   #:use-module (gnu packages xml)
   #:use-module (gnu packages xorg)
@@ -1510,43 +1508,6 @@ (define-public python-pytest-qt
 interaction, like key presses and mouse clicks.")
     (license license:expat)))
 
-(define-public python-codeclimate-test-reporter
-  (package
-    (name "python-codeclimate-test-reporter")
-    (version "0.2.3")
-    (source
-     (origin
-       (method git-fetch)               ;no tests in pypi archive
-       (uri (git-reference
-             (url "https://github.com/codeclimate/python-test-reporter")
-             (commit (string-append "v" version))))
-       (file-name (git-file-name name version))
-       (sha256
-        (base32
-         "0mxph5l3k9ch4hs9l76k4wnmzhd94bylg92lvm2priyn24gkn9a1"))))
-    (build-system python-build-system)
-    (native-inputs
-     (list git-minimal/fixed
-           python-httpretty
-           python-pytest))
-    (propagated-inputs
-     (list (package
-             (inherit python-coverage)
-             (version "4.3.4")
-             (source
-              (origin
-                (method url-fetch)
-                (uri (pypi-uri "coverage" version))
-                (sha256
-                 (base32
-                  "1prkwz1hkcbx19nsadbcmk4wl27ysx001pa8bykfagd3d87zxbpa")))))
-           python-requests))
-    (home-page "https://github.com/codeclimate/python-test-reporter")
-    (synopsis "Reports test coverage to Code Climate")
-    (description "This package provides @{codclimate-test-reporter}, a Python
-library teport test coverage to Code Climate.")
-    (license license:expat)))
-
 (define-public python-codacy-coverage
   (package
     (name "python-codacy-coverage")
diff --git a/gnu/packages/python-xyz.scm b/gnu/packages/python-xyz.scm
index 7ed6de5a2b..eac19ca1a5 100644
--- a/gnu/packages/python-xyz.scm
+++ b/gnu/packages/python-xyz.scm
@@ -63,7 +63,7 @@
 ;;; Copyright © 2019, 2020 Alex Griffin <a@ajgrf.com>
 ;;; Copyright © 2019, 2020, 2021 Pierre Langlois <pierre.langlois@gmx.com>
 ;;; Copyright © 2019 Jacob MacDonald <jaccarmac@gmail.com>
-;;; Copyright © 2019, 2020, 2021 Giacomo Leidi <goodoldpaul@autistici.org>
+;;; Copyright © 2019-2022 Giacomo Leidi <goodoldpaul@autistici.org>
 ;;; Copyright © 2019 Wiktor Żelazny <wzelazny@vurv.cz>
 ;;; Copyright © 2019, 2020, 2021, 2022 Tanguy Le Carrour <tanguy@bioneland.org>
 ;;; Copyright © 2019, 2021 Mădălin Ionel Patrașcu <madalinionel.patrascu@mdc-berlin.de>
@@ -26530,6 +26530,43 @@ (define-public python-flufl-lock
     (license (list license:asl2.0
                    license:lgpl3))))    ; only for setup_helpers.py
 
+(define-public python-codeclimate-test-reporter
+  (package
+    (name "python-codeclimate-test-reporter")
+    (version "0.2.3")
+    (source
+     (origin
+       (method git-fetch)               ;no tests in pypi archive
+       (uri (git-reference
+             (url "https://github.com/codeclimate/python-test-reporter")
+             (commit (string-append "v" version))))
+       (file-name (git-file-name name version))
+       (sha256
+        (base32
+         "0mxph5l3k9ch4hs9l76k4wnmzhd94bylg92lvm2priyn24gkn9a1"))))
+    (build-system python-build-system)
+    (native-inputs
+     (list git-minimal/fixed
+           python-httpretty
+           python-pytest))
+    (propagated-inputs
+     (list (package
+             (inherit python-coverage)
+             (version "4.3.4")
+             (source
+              (origin
+                (method url-fetch)
+                (uri (pypi-uri "coverage" version))
+                (sha256
+                 (base32
+                  "1prkwz1hkcbx19nsadbcmk4wl27ysx001pa8bykfagd3d87zxbpa")))))
+           python-requests))
+    (home-page "https://github.com/codeclimate/python-test-reporter")
+    (synopsis "Reports test coverage to Code Climate")
+    (description "This package provides @{codclimate-test-reporter}, a Python
+library teport test coverage to Code Climate.")
+    (license license:expat)))
+
 (define-public python-flufl-testing
   (package
     (name "python-flufl-testing")