diff --git a/gnu/packages/crypto.scm b/gnu/packages/crypto.scm
index 63be51f86a21..89694f111e17 100644
--- a/gnu/packages/crypto.scm
+++ b/gnu/packages/crypto.scm
@@ -826,8 +826,8 @@ (define-public libb2
     (arguments
      `(#:configure-flags
        (list
-        ,@(if (any (cute string-prefix? <> (or (%current-system)
-                                               (%current-target-system)))
+        ,@(if (any (cute string-prefix? <> (or (%current-target-system)
+                                               (%current-system)))
                    '("x86_64" "i686"))
               ;; fat only checks for Intel optimisations
               '("--enable-fat")
diff --git a/gnu/packages/java.scm b/gnu/packages/java.scm
index aead02d93c31..77f9f7e8fb86 100644
--- a/gnu/packages/java.scm
+++ b/gnu/packages/java.scm
@@ -207,8 +207,8 @@ (define jamvm-1-bootstrap
              "--enable-runtime-reloc-checks"
              "--enable-ffi")
        #:phases
-       ,(if (string-prefix? "aarch64" (or (%current-system)
-                                          (%current-target-system)))
+       ,(if (string-prefix? "aarch64" (or (%current-target-system)
+                                          (%current-system)))
             ;; Makefiles and the configure script need to be regenerated to
             ;; incorporate support for AArch64.
             '(modify-phases %standard-phases
@@ -218,8 +218,8 @@ (define jamvm-1-bootstrap
     (inputs
      (list classpath-bootstrap jikes libffi zip zlib))
     (native-inputs
-     (if (string-prefix? "aarch64" (or (%current-system)
-                                       (%current-target-system)))
+     (if (string-prefix? "aarch64" (or (%current-target-system)
+                                       (%current-system)))
          ;; Additional packages needed for autoreconf.
          `(("autoconf" ,autoconf)
            ("automake" ,automake)
@@ -285,8 +285,8 @@ (define ant-bootstrap
              ;; Without these JamVM options the build may freeze.
              (substitute* "bootstrap.sh"
                (("^\"\\$\\{JAVACMD\\}\" " m)
-                ,@(if (string-prefix? "armhf" (or (%current-system)
-                                                  (%current-target-system)))
+                ,@(if (string-prefix? "armhf" (or (%current-target-system)
+                                                  (%current-system)))
                       `((string-append m "-Xnocompact "))
                       `((string-append m "-Xnocompact -Xnoinlining ")))))
 
@@ -535,8 +535,8 @@ (define classpath-jamvm-wrappers
             (for-each (lambda (tool)
                         (with-output-to-file (string-append bin tool)
                           (lambda _
-                            #$@(if (string-prefix? "armhf" (or (%current-system)
-                                                               (%current-target-system)))
+                            #$@(if (string-prefix? "armhf" (or (%current-target-system)
+                                                               (%current-system)))
                                    `((format #t "#!~a/bin/sh
 ~a/bin/jamvm -Xnocompact -classpath ~a/share/classpath/tools.zip \
 gnu.classpath.tools.~a.~a $@"
diff --git a/gnu/packages/photo.scm b/gnu/packages/photo.scm
index 2f561abc2f31..eaa905dd3b8c 100644
--- a/gnu/packages/photo.scm
+++ b/gnu/packages/photo.scm
@@ -426,8 +426,8 @@ (define-public lensfun
                 "0cfk8jjhs9nbfjfdy98plrj9ayi59aph0nx6ppslgjhlcvacm2xf"))))
     (build-system cmake-build-system)
     (arguments
-     `(,@(if (any (cute string-prefix? <> (or (%current-system)
-                                              (%current-target-system)))
+     `(,@(if (any (cute string-prefix? <> (or (%current-target-system)
+                                              (%current-system)))
                   '("x86_64" "i686"))
         ;; SSE and SSE2 are supported only on Intel processors.
         '()
diff --git a/gnu/packages/php.scm b/gnu/packages/php.scm
index 191dcafb4ae4..e2489d2435a6 100644
--- a/gnu/packages/php.scm
+++ b/gnu/packages/php.scm
@@ -177,8 +177,8 @@ (define-public php
              (substitute* "ext/standard/tests/streams/bug60602.phpt"
                (("'ls'") (string-append "'" (which "ls") "'")))
 
-             ,@(if (string-prefix? "arm" (or (%current-system)
-                                             (%current-target-system)))
+             ,@(if (string-prefix? "arm" (or (%current-target-system)
+                                             (%current-system)))
                    ;; Drop tests known to fail on armhf.
                    '((for-each delete-file
                               (list
diff --git a/gnu/packages/sdl.scm b/gnu/packages/sdl.scm
index 4c38e2f05507..a5892934d824 100644
--- a/gnu/packages/sdl.scm
+++ b/gnu/packages/sdl.scm
@@ -198,8 +198,8 @@ (define-public sdl-gfx
     (build-system gnu-build-system)
     (outputs '("out" "debug"))
     (arguments
-     `(,@(if (any (cute string-prefix? <> (or (%current-system)
-                                              (%current-target-system)))
+     `(,@(if (any (cute string-prefix? <> (or (%current-target-system)
+                                              (%current-system)))
                   '("x86_64" "i686"))
         ;; mmx is supported only on Intel processors.
         '()
diff --git a/gnu/packages/telephony.scm b/gnu/packages/telephony.scm
index e3071d9b75a7..c694a906f1d0 100644
--- a/gnu/packages/telephony.scm
+++ b/gnu/packages/telephony.scm
@@ -755,8 +755,8 @@ (define-public pjproject
              "--with-external-srtp"
              "--with-external-pa"
              ;; The following flag is Linux specific.
-             ,@(if (string-contains (or (%current-system)
-                                        (%current-target-system)) "linux")
+             ,@(if (string-contains (or (%current-target-system)
+                                        (%current-system)) "linux")
                    '("--enable-epoll")
                    '())
              "--with-gnutls"            ;disable OpenSSL checks