diff --git a/gnu/packages/chromium.scm b/gnu/packages/chromium.scm
index 7ef1e5ac1b..f60c9719fe 100644
--- a/gnu/packages/chromium.scm
+++ b/gnu/packages/chromium.scm
@@ -849,7 +849,7 @@ (define-public ungoogled-chromium
            opus+custom
            pango
            pciutils
-           pipewire-0.3
+           pipewire
            pulseaudio
            re2
            snappy
diff --git a/gnu/packages/freedesktop.scm b/gnu/packages/freedesktop.scm
index 55bde8e705..b1248c466d 100644
--- a/gnu/packages/freedesktop.scm
+++ b/gnu/packages/freedesktop.scm
@@ -1120,7 +1120,7 @@ (define-public weston
        ("mtdev" ,mtdev)
        ("linux-pam" ,linux-pam)
        ("pango" ,pango)
-       ("pipewire" ,pipewire)
+       ("pipewire" ,pipewire-0.2)
        ("wayland-protocols" ,wayland-protocols)
        ("xorg-server-xwayland" ,xorg-server-xwayland)))
     (propagated-inputs
@@ -2313,7 +2313,7 @@ (define-public xdg-desktop-portal
        ("libportal" ,libportal)
        ("dbus" ,dbus)
        ("geoclue" ,geoclue)
-       ("pipewire" ,pipewire-0.3)
+       ("pipewire" ,pipewire)
        ("fuse" ,fuse)))
     (arguments
      `(#:phases
@@ -2442,7 +2442,7 @@ (define-public xdg-desktop-portal-wlr
                   grim
                   iniparser
                   libinih
-                  pipewire-0.3
+                  pipewire
                   slurp
                   wayland
                   wayland-protocols))
diff --git a/gnu/packages/gnome.scm b/gnu/packages/gnome.scm
index 8ff59f084b..41b1a1c010 100644
--- a/gnu/packages/gnome.scm
+++ b/gnu/packages/gnome.scm
@@ -7557,7 +7557,7 @@ (define-public mutter
        ;; theme to please libxcursor.
        ("adwaita-icon-theme" ,adwaita-icon-theme)
        ("libxcursor" ,libxcursor)       ;for XCURSOR_PATH
-       ("pipewire" ,pipewire-0.3)
+       ("pipewire" ,pipewire)
        ("python" ,python)
        ("python-dbus" ,python-dbus)
        ("python-dbusmock" ,python-dbusmock)
@@ -7600,7 +7600,7 @@ (define-public mutter
        ("libxkbfile" ,libxkbfile)
        ("libxrandr" ,libxrandr)
        ("libxtst" ,libxtst)
-       ("pipewire" ,pipewire-0.3)
+       ("pipewire" ,pipewire)
        ("startup-notification" ,startup-notification)
        ("sysprof" ,sysprof)
        ("upower-glib" ,upower)
diff --git a/gnu/packages/kde-systemtools.scm b/gnu/packages/kde-systemtools.scm
index 3fab9089f3..205cd24e9d 100644
--- a/gnu/packages/kde-systemtools.scm
+++ b/gnu/packages/kde-systemtools.scm
@@ -254,7 +254,7 @@ (define-public krfb
            libxcb
            libxtst
            oxygen-icons ;; default icon set
-           pipewire-0.3
+           pipewire
            qtbase-5
            qtx11extras
            xcb-util-image
diff --git a/gnu/packages/linux.scm b/gnu/packages/linux.scm
index 11330410ce..d633ded1d3 100644
--- a/gnu/packages/linux.scm
+++ b/gnu/packages/linux.scm
@@ -8274,7 +8274,7 @@ (define-public inputattach
 types and interfaces and translates so that the X server can use them.")
     (license license:gpl2+)))
 
-(define-public pipewire
+(define-public pipewire-0.2
   (package
     (name "pipewire")
     (version "0.2.7")
@@ -8315,9 +8315,9 @@ (define-public pipewire
 of Linux application development.")
     (license license:lgpl2.0+)))
 
-(define-public pipewire-0.3
+(define-public pipewire
   (package
-    (inherit pipewire)
+    (inherit pipewire-0.2)
     (name "pipewire")
     (version "0.3.49")
     (source (origin
@@ -8339,9 +8339,9 @@ (define-public pipewire-0.3
        (modify-phases %standard-phases
          ;; Skip shrink-runpath, otherwise validate-runpath fails.
          (delete 'shrink-runpath))))
-    (native-inputs (modify-inputs (package-native-inputs pipewire)
+    (native-inputs (modify-inputs (package-native-inputs pipewire-0.2)
                      (prepend python-docutils))) ; For manpages.
-    (inputs (modify-inputs (package-inputs pipewire)
+    (inputs (modify-inputs (package-inputs pipewire-0.2)
               (prepend avahi
                        bluez
                        jack-2
@@ -8378,7 +8378,7 @@ (define-public wireplumber
     (native-inputs
      (list `(,glib "bin")
            pkg-config))
-    (inputs (list dbus elogind glib lua pipewire-0.3))
+    (inputs (list dbus elogind glib lua pipewire))
     (home-page "https://gitlab.freedesktop.org/pipewire/wireplumber")
     (synopsis "Session / policy manager implementation for PipeWire")
     (description "WirePlumber is a modular session / policy manager for
diff --git a/gnu/packages/telegram.scm b/gnu/packages/telegram.scm
index 6c5efc50b9..4213ac6e4e 100644
--- a/gnu/packages/telegram.scm
+++ b/gnu/packages/telegram.scm
@@ -166,7 +166,7 @@ (define-public webrtc-for-telegram-desktop
           ("libxrandr" ,libxrandr)
           ("openssl" ,openssl)
           ("opus" ,opus)
-          ("pipewire" ,pipewire)
+          ("pipewire" ,pipewire-0.2)
           ("protobuf" ,protobuf)
           ("pulseaudio" ,pulseaudio)
           ("x11" ,libx11)
diff --git a/gnu/packages/video.scm b/gnu/packages/video.scm
index dc05c0a222..a5298ccfac 100644
--- a/gnu/packages/video.scm
+++ b/gnu/packages/video.scm
@@ -3429,7 +3429,7 @@ (define-public obs
       libxcomposite
       mbedtls-apache
       mesa
-      pipewire-0.3
+      pipewire
       pulseaudio
       qtbase-5
       qtsvg